<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class gallery2class {

	const G2EMBEDPATH = DRUPAL_ROOT.'/gallery2';
	private  $item, $id;

	public function __construct($embedPath = self::G2EMBEDPATH) {
		require_once(__DIR__ . '/simple_html_dom.php');
		require_once($embedPath . '/embed.php');
		GalleryEmbed::init(array('fullInit' => true, 'embedUri' => '/gallery2/main.php', 'g2Uri' => '/gallery2/'));
	}

	public function g2Item($pathOrId, $lboxMaxEdge = 848) {
		if (is_numeric($pathOrId)) {
			$id = $pathOrId;
		} else {
			$id = $this->getIdFromPath($pathOrId);
		}
		//$g2Item['tumbSrc']= $this->getThumbSrcFromId($id);
		$resizedID = $this->getResizedID($id, $lboxMaxEdge);

		$g2Item['id'] = $this->getRootIdFromId($id);
		$g2Item['title'] = $this->getTitleFromId($id);
		$g2Item['description'] = $this->getDescriptionFromId($id);
		$g2Item['shortdescription'] = $this->getShortDescriptionFromId($id);
		$g2Item['imgpage'] = $this->getImgPagePathFromId($id);
		$g2Item['src'] = $this->getImgSrcFromId($resizedID);
		$g2Item['thumbsrc'] = $this->getThumbSrcFromId($resizedID);
		$g2Item['width'] = $this->getWidthFromId($resizedID);
		$g2Item['height'] = $this->getHeightFromId($resizedID);
		$g2Item['g2page'] = $this->getImgPagePathFromId($resizedID);
		return $g2Item;
	}

	private function getIdFromPath($path) {
		$path = parse_url($path, PHP_URL_PATH);
		$a1 = explode('/', $path);
		$id = substr($a1[3], 0, strpos($a1[3], '-'));
		list($ret, $item) = GalleryCoreApi::loadEntitiesById($id);
		if ($ret) {
			return null;
		}
		return $item->getid();
	}

	private function getItemFromId($id) {
		list($ret, $item) = GalleryCoreApi::loadEntitiesById($id);
		if ($ret) {
			return null;
		}
		return $item;
	}

	private function getWidthFromId($id) {
		list($ret, $item) = GalleryCoreApi::loadEntitiesById($id);
		if ($ret) {
			return null;
		}
		return $item->getWidth();
	}

	private function getHeightFromId($id) {
		list($ret, $item) = GalleryCoreApi::loadEntitiesById($id);
		if ($ret) {
			return null;
		}
		return $item->getHeight();
	}

	private function getThumbSrcFromId($id) {
		list($ret, $item) = GalleryCoreApi::loadEntitiesById($id);
		if ($ret) {
			return null;
		}
		switch ($item->entityType) {
			case "GalleryPhotoItem":
				$id = $item->getid();
				break;
			case "GalleryDerivativeImage":
			case "ThumbnailImage":
				$id = $item->getparentId();
				break;
			default:
				return null;
		}
		list($ret, $thumbId) = GalleryCoreApi::fetchThumbnailsByItemIds((array) $id);
		//print_r($id);
		$tid = $thumbId[$id]->getid();
		return $this->getImgSrcFromId($tid);
	}

	private function getSiteName() {
		$protocol = strtolower(substr($_SERVER["SERVER_PROTOCOL"], 0, strpos($_SERVER["SERVER_PROTOCOL"], '/'))) . '://';
		return $protocol . $_SERVER['HTTP_HOST'];
	}

	private function getTitleFromId($id) {
		$item = $this->getItemFromId($this->getRootIdFromId($id));
		if (!$item)
			return null;
		$title = $item->gettitle();
		$title = str_replace(array('"'), '\\"', $title);
		
		return $title;
	}

	private function getShortDescriptionFromId($id) {
		$item = $this->getItemFromId($this->getRootIdFromId($id));
		if (!$item)
			return null;
		$shortdescription = preg_replace("'<blockquote[^>]*?>.*?</blockquote>'si", "", html_entity_decode($item->getdescription()));
		$shortdescription = strip_tags($shortdescription);
		$shortdescription = str_replace(array('"'), '\\"', $shortdescription);
		return $shortdescription;
	}

	private function getDescriptionFromId($id) {
		$item = $this->getItemFromId($this->getRootIdFromId($id));
		if (!$item)
			return null;
		$description = html_entity_decode($item->getdescription());
		$description = str_replace(array("\n","\r"), '', $description);
		$description = str_replace(array('"'),'\\"',$description);
		return $description;
	}

	private function getImgPagePathFromId_helper($item) {
		if ($item->getparentId() == null) {
			return '/gallery2/v';
		}
		$parentid = $item->parentId;
		list($ret, $parent) = GalleryCoreApi::loadEntitiesById($parentid);

		return $path = str_replace('//', '/', $this->getImgPagePathFromId_helper($parent) . '/' . str_replace(" ", "+", $item->pathComponent));
	}

	private function getImgPagePathFromId($id) {
		$item = $this->getItemFromId($this->getRootIdFromId($id));
		if ((!$item) || ($item->getentityType() != 'GalleryPhotoItem')) {
			return null;
		}
		$path = $this->getImgPagePathFromId_helper($item);
		if (!$path) {
			return null;
		}

		$this->removeTrailingSlash($path);
		return $this->getSiteName() . $path . '.html';
	}

	private function removeTrailingSlash(&$string) {
		if (substr($string, -1) == '/') {
			$string = substr($string, 0, -1);
		}
	}

	private function getRootIdFromId($id) {
		$item = $this->getItemFromId($id);
		if (!$item)
			return null;
		switch ($item->getentityType()) {
			case "GalleryPhotoItem":
				$rootItemId = $item->getId();
				break;
			case "GalleryDerivativeImage":
			case "ThumbnailImage":
				$rootItemId = $item->getparentId();
				break;
			default:
				$rootItemId = null;
		}
		return $rootItemId;
	}

	private function getRootImgSrcFromId($id) {
		$rootItemId = $this->getRootIdFromId($id);
		$rootItem = $this->getItemFromId($rootItemId);
		return $this->getSiteName() . "/gallery2/d/$rootItemId-" . $rootItem->getserialNumber() . "/" . $rootItem->getpathComponent();
	}

	private function getImgSrcFromId($id) {
		$item = $this->getItemFromId($id);
		if (!$item)
			return null;
		$rootItemId = $this->getRootIdFromId($id);
		$rootItem = $this->getItemFromId($rootItemId);
		return $this->getSiteName() . "/gallery2/d/$id-" . $item->getSerialNumber() . "/" . $rootItem->getpathComponent();
	}

	private function getResizedID($id, $lboxMaxEdge = 848) {
		$item = $this->getItemFromId($this->getRootIdFromId($id));
		if (!$item)
			return null;
		if ($item->entityType <> "GalleryPhotoItem")
			return null;
		$resizes = array();
		$resizedEdge = 0;
		$resizedId = $item->getId();
		if (!$width = $item->getWidth())
			return 0;

		$height = $item->getHeight();


		$edge = ($width > $height) ? $width : $height;
		//$edge   = $width;

		list($ret, $resizes) = GalleryCoreApi::fetchResizesByItemIds(
						array($item->getId()));

		if (isset($imgs))
			unset($imgs);
		$imgs = array();

		$i = 0;
		if ($item->mimeType == 'image/jpeg') {
			$imgs[0]['edge'] = $edge;
			$imgs[0]['id'] = $item->getId();
			$i = 1;
		}
		//    print_r($item); echo '===============';
		foreach ($resizes[$item->getId()] as $resize) {
			$width = $resize->getWidth();
			$height = $resize->getHeight();

			//$edge             = $width;

			$edge = ($width > $height) ? $width : $height;
			//$edge   = $width;
			$imgs[$i]['edge'] = $edge;


			$imgs[$i]['id'] = $resize->getId();
			//echo $imgs[$i]['edge'].'------'.$imgs[$i][id].'<br>';
			$i++;
		}

		sort($imgs);

		for ($i = 0; $i < count($imgs); $i++) {

			if ($imgs[$i]['edge'] >= $lboxMaxEdge) {
				//print_r($lboxMaxEdge);
				return $imgs[$i]['id'];
			}
		}
		return $imgs[count($imgs) - 1]['id'];
	}

}
